/**
 * AttributeTypes.java
 *
 * File generated from the LDAStructure::AttributeTypes uml Class
 * Generated by IHE - europe, gazelle team
 */
package net.ihe.gazelle.ldap.model;

// End of user code
import javax.persistence.*;
import javax.xml.bind.annotation.*;

import org.jboss.seam.annotations.Name;

/**
 * Description of the class AttributeTypes.
 * 
 */

@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "AttributeTypes", propOrder = { "singlevalue", "syntax", "equality", "ordering", "substr", "length" })
@XmlRootElement(name = "AttributeTypes")
@Entity
@Name("attributeTypes")
@Table(name = "hpd_ldap_attribute_types", schema = "public", uniqueConstraints = @UniqueConstraint(columnNames = "name"))
@SequenceGenerator(name = "hpd_ldap_attribute_types_sequence", sequenceName = "hpd_ldap_attribute_types_id_seq", allocationSize = 1)
public class AttributeTypes extends AbstractStructure implements java.io.Serializable {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	@Id
	@GeneratedValue(generator = "hpd_ldap_attribute_types_sequence", strategy = GenerationType.SEQUENCE)
	@Column(name = "id", nullable = false, unique = true)
	@XmlTransient
	private Integer id;

	@XmlElement(name = "singlevalue")
	public Boolean singlevalue;
	@XmlElement(name = "syntax")
	public java.lang.String syntax;
	@XmlElement(name = "equality")
	public Equality equality;
	@XmlElement(name = "ordering")
	public Ordering ordering;
	@XmlElement(name = "substr")
	public Substr substr;
	@XmlElement(name = "length")
	public Integer length;

	public AttributeTypes() {
		super();
	}

	public AttributeTypes(AttributeTypes inType, String newName) {
		super();
		this.name = newName;
		this.oid = inType.getOid();
		this.description = inType.getDescription();
		this.singlevalue = inType.getSinglevalue();
		this.syntax = inType.getSyntax();
		this.equality = inType.getEquality();
		this.ordering = inType.getOrdering();
		this.substr = inType.getSubstr();
		this.length = inType.getLength();
	}

	/**
	 * Return singlevalue.
	 * 
	 * @return singlevalue
	 */
	public Boolean getSinglevalue() {
		return singlevalue;
	}

	/**
	 * Set a value to attribute singlevalue.
	 * 
	 * @param singlevalue
	 *            .
	 */
	public void setSinglevalue(Boolean singlevalue) {
		this.singlevalue = singlevalue;
	}

	/**
	 * Return singlevalue.
	 * 
	 * @return singlevalue Generated for the use on jsf pages
	 */
	public Boolean isSinglevalue() {
		return singlevalue;
	}

	/**
	 * Return syntax.
	 * 
	 * @return syntax
	 */
	public java.lang.String getSyntax() {
		return syntax;
	}

	/**
	 * Set a value to attribute syntax.
	 * 
	 * @param syntax
	 *            .
	 */
	public void setSyntax(java.lang.String syntax) {
		this.syntax = syntax;
	}

	/**
	 * Return equality.
	 * 
	 * @return equality
	 */
	public Equality getEquality() {
		return equality;
	}

	/**
	 * Set a value to attribute equality.
	 * 
	 * @param equality
	 *            .
	 */
	public void setEquality(Equality equality) {
		this.equality = equality;
	}

	/**
	 * Return ordering.
	 * 
	 * @return ordering
	 */
	public Ordering getOrdering() {
		return ordering;
	}

	/**
	 * Set a value to attribute ordering.
	 * 
	 * @param ordering
	 *            .
	 */
	public void setOrdering(Ordering ordering) {
		this.ordering = ordering;
	}

	/**
	 * Return substr.
	 * 
	 * @return substr
	 */
	public Substr getSubstr() {
		return substr;
	}

	/**
	 * Set a value to attribute substr.
	 * 
	 * @param substr
	 *            .
	 */
	public void setSubstr(Substr substr) {
		this.substr = substr;
	}

	/**
	 * Return length.
	 * 
	 * @return length
	 */
	public Integer getLength() {
		return length;
	}

	/**
	 * Set a value to attribute length.
	 * 
	 * @param length
	 *            .
	 */
	public void setLength(Integer length) {
		this.length = length;
	}

	public static AttributeTypes getAttributeTypeByName(String inName) {
		if ((inName != null) && !inName.isEmpty()) {
			AttributeTypesQuery query = new AttributeTypesQuery();
			query.name().eq(inName);
			return query.getUniqueResult();
		} else {
			return null;
		}
	}

	public Integer getId() {
		return id;
	}
}